#include "ofApp.h"

//--------------------------------------------------------------
void ofApp::setup(){
    ofSetBackgroundColor(0, 0, 40);
    ofSetLogLevel(OF_LOG_VERBOSE);
    
    
    // enable depth->video image calibration
    kinect.setRegistration(true);
    
    kinect.init();
    kinect.init(true); //< TURN ON IR ONLY
    
    //kinect.init(false, false); // disable video image (faster fps)
    
    kinect.open();
    lightThreshold = 254;
    
    colorImg.allocate(kinect.width, kinect.height);
    grayImg.allocate(kinect.width, kinect.height);
    ofSetFrameRate(60);
    
    maxBrightnessX = 0;
    maxBrightnessY = 0;
    
    locX = 0;
    locY = 0;
    
    //DRAWING variables
    lastX=0;
    lastY=0;
    
    locMappedX = 0;
    locMappedY = 0;
    
    drawActivate=false;
    drawSwitch = false;
    pointWeight = 2;
    
    clicked = false;
    
    colorPickerBegin = false;
    
    ofSetPolyMode(OF_POLY_WINDING_NONZERO);
    
    newShape == true;
    
    

    
    
    
    
    color1 = ofColor(ofRandom(50, 255),ofRandom(50, 255),ofRandom(50, 255));
    color2 = ofColor(ofRandom(50, 255),ofRandom(50, 255),ofRandom(50, 255));
    color3 = ofColor(ofRandom(50, 255),ofRandom(50, 255),ofRandom(50, 255));
    color4 = ofColor(ofRandom(50, 255),ofRandom(50, 255),ofRandom(50, 255));
    color5 = ofColor(ofRandom(50, 255),ofRandom(50, 255),ofRandom(50, 255));
    
    

    
    
    
    
    
}

//--------------------------------------------------------------
void ofApp::update(){
    //Map lightThreshold so I can control it with a move of the mouse
    //lightThreshold=ofMap(mouseX, 0, ofGetWidth(), 0, 255);
    
    
    // there is a new frame and we are connected
    if(kinect.isFrameNew()) {
        
        // load grayscale depth image from the kinect source
        grayImg.setFromPixels(kinect.getPixels());
    }
    
    //cout<<"shapeholdersize:"<<shapeHolder.size()<<endl;
    

    
    


    

    
}

//--------------------------------------------------------------
void ofApp::draw(){
    kinect.update();
    
    
    float maxBrightness = 0; // these are used in the search
    
    
    int w = grayImg.getWidth();
    int h = grayImg.getHeight();
    ofPixels & pixels = grayImg.getPixels();
    
    
    for(int y=0; y< h; y++) {
        for(int x=0; x< w; x++) {
            //curPix represents the current pixel we're looking at
            int indexLight = (y*w)+x;
            
            if(pixels[indexLight] > lightThreshold) {
                pixels[indexLight] = 255;
            } else {
                pixels[indexLight] = 0;
            }
            
            float brightnessOfColorAtCoords = pixels[indexLight];
            if(brightnessOfColorAtCoords > maxBrightness) {
                maxBrightness  = brightnessOfColorAtCoords;
                maxBrightnessX = x;
                maxBrightnessY = y;
            }
        }
    }
    
    
    // SEE ORIGINAL VIDEO BY UNCOMMENTING BELOW
    //    ofSetColor (255);
    //    grayImg.draw(0,0,ofGetWidth(), ofGetHeight());
    //    kinect.draw(690, 0);
    
    

    ofSetColor(255,0,0);
    locX = ofMap(maxBrightnessX, 0, w, 0, ofGetWidth());
    locY = ofMap(maxBrightnessY, 0, h,0, ofGetHeight());
    
    
    
    
    
    
    if(colorPickerBegin) {
        ofSetColor(255,0,0);
        ofDrawBitmapString("color1", 100, 100);
        ofSetColor(255, 255, 0);
        ofDrawBitmapString("color2", 100, 115);
        ofSetColor(0,127,255);
        ofDrawBitmapString("color3", 100, 130);
        ofSetColor(0,255,100);
        ofDrawBitmapString("color4", 100, 145);
        

    }
    
    //DRAWING
    
    ofNoFill();
    ofSetColor(255, 255, 255);
    ofSetLineWidth(pointWeight);
    ofSetCircleResolution(60);
    ofDrawEllipse(locMappedX, locMappedY, 30, 30);

    //ofMesh drawing;
    
    
    
//    if(locMappedX != 0 || locMappedY != 0) {
//        
//    }
    
    
    ofSetColor(colorChoice);
    
    for(int v=0; v<myLines.size();v++){
        ofSetLineWidth(2);
        myLines[v].draw();
    }
    //WHEN SPACE BAR IS PRESSED we add points to the vertex
    if(drawActivate) {
        ofPoint pt;
        pt.set(locMappedX,locMappedY);
        myLines[myLines.size()-1].addVertex(pt);
    }

//    for(int v=0; v<testLines.size();v++){
//        testLines[v].draw();
//    }
//    
//    if(drawActivate) {
//        ofPoint pt;
//        pt.set(mouseX,mouseY);
//        testLines[testLines.size()-1].addVertex(pt);
//    }
    
    //LIVE CALIBRATION SETTINGS
    int leftSide = (tLX + bLX)/2;
    int topSide = (tLY + tRY)/2;
    int rightSide = (tRX + bRX)/2;
    int botSide = (bLY + bRY)/2;

    
    ofNoFill();
    ofSetColor(255);
    //CALIBRATION PRINT
    ofDrawBitmapString(leftSide, 100, ofGetHeight()-10);
    ofDrawBitmapString(rightSide, 100, ofGetHeight()-25);
    ofDrawBitmapString(topSide, 100, ofGetHeight()-40);
    ofDrawBitmapString(botSide, 100, ofGetHeight()-55);
    
    locMappedX = ofMap(locX, leftSide, rightSide, 0, ofGetWidth());
    locMappedY = ofMap(locY, topSide, botSide, 0, ofGetHeight());
    
    //cout<<locX<<", "<<locY<<endl;
    
    //PRINT CORNERS
    ofDrawBitmapString(tLX, 10, ofGetHeight()-10);
    ofDrawBitmapString(tLY, 50, ofGetHeight()-10);
    ofDrawBitmapString(tRX, 10, ofGetHeight()-25);
    ofDrawBitmapString(tRY, 50, ofGetHeight()-25);
    ofDrawBitmapString(bRX, 10, ofGetHeight()-40);
    ofDrawBitmapString(bRY, 50, ofGetHeight()-40);
    ofDrawBitmapString(bLX, 10, ofGetHeight()-55);
    ofDrawBitmapString(bLY, 50, ofGetHeight()-55);
    
    //PRINT COLORS
    ofSetColor(color1);
    ofDrawBitmapString(color1, 300, ofGetHeight()-20);
    ofSetColor(color2);
    ofDrawBitmapString(color2, 500, ofGetHeight()-20);
    ofSetColor(color3);
    ofDrawBitmapString(color3, 700, ofGetHeight()-20);
    ofSetColor(color4);
    ofDrawBitmapString(color4, 900, ofGetHeight()-20);
    ofSetColor(color5);
    ofDrawBitmapString(color5, 1100, ofGetHeight()-20);

}

//--------------------------------------------------------------
void ofApp::keyPressed(int key){
    
    if (key == 'f'){
        ofToggleFullscreen();
    }
    
    //Q, E, C, and Z set the coordinates of the top left, top right, bottom right, and bottom left corners, respectively
    if (key == 'q') {
        tLX= locX;
        tLY= locY;
    }
    
    if (key == 'e') {
        tRX= locX;
        tRY= locY;
    }
    
    if (key == 'c') {
        bRX= locX;
        bRY= locY;
    }
    
    if (key== 'z') {
        bLX = locX;
        bLY = locY;
    }
    
//    if (key == 'p'){
//        colorPickerBegin=true;
//    }
    
    //SPACE BAR Triggers drawing mode
    if(key == ' '){
        drawActivate=!drawActivate;
        
        if(drawActivate){
            pointWeight = 5;
            ofPolyline newLine;
            myLines.push_back(newLine);
        }else{
            pointWeight=2;
            if(myLines.size()>0) myLines[myLines.size()-1].close();
        }
        
//        drawActivate=!drawActivate;
//        if(drawActivate){
//            ofPolyline newLine;
//            testLines.push_back(newLine);
//            cout << testLines.size() << endl;
//        }else{
//            if(testLines.size()>0) testLines[testLines.size()-1].close();
//        }
        
    }
    
    
    //PRESSING A NUM KEY 1-5 WILL CHANGE THE COLOR
    if (key== '1') {
        colorChoice = color1;
    }
    if (key== '2') {
        colorChoice = color2;
    }
    if (key== '3') {
        colorChoice = color3;
    }
    if (key== '4') {
        colorChoice = color4;
    }
    if (key== '5') {
        colorChoice = color5;
    }
    
}

//--------------------------------------------------------------
void ofApp::keyReleased(int key){

}

//--------------------------------------------------------------
void ofApp::mouseMoved(int x, int y ){
    
}

//--------------------------------------------------------------
void ofApp::mouseDragged(int x, int y, int button){
    
    
}

//--------------------------------------------------------------
void ofApp::mousePressed(int x, int y, int button){
    myLines.clear();
    
}

//--------------------------------------------------------------
void ofApp::mouseReleased(int x, int y, int button){
    
}

//--------------------------------------------------------------
void ofApp::mouseEntered(int x, int y){
    
}

//--------------------------------------------------------------
void ofApp::mouseExited(int x, int y){
    
}

//--------------------------------------------------------------
void ofApp::windowResized(int w, int h){
    
}

//--------------------------------------------------------------
void ofApp::gotMessage(ofMessage msg){
    
}

//--------------------------------------------------------------
void ofApp::dragEvent(ofDragInfo dragInfo){
    
}
