#pragma once

#include "ofMain.h"
#include "ofxOpenCv.h"
#include "ofxKinect.h"



class ofApp : public ofBaseApp{

	public:
		void setup();
		void update();
		void draw();

		void keyPressed(int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void mouseEntered(int x, int y);
		void mouseExited(int x, int y);
		void windowResized(int w, int h);
		void dragEvent(ofDragInfo dragInfo);
		void gotMessage(ofMessage msg);

    
    ofxKinect kinect;
    
    ofxCvColorImage colorImg;
    ofxCvGrayscaleImage grayImg;
    
    ofxCvContourFinder 	contourFinder;
    
    int maxBrightnessX, maxBrightnessY;
    int locX, locY;
    
    int lightThreshold;
    

    
    //EXPIRMENTAL variables
    struct lineShapes {
        float lineIndex;
    };
    
    
    
    vector<float> lines;
    
//    vector < vector<ofPoint> > shapeHolder;
    
    
    //DRAWING variables
    //ofPolyline line;
    
    vector <ofPolyline> myLines;
    
    vector <ofPolyline> testLines;
    
    ofPolyline drawing;
    int lastX, lastY;
    int dist;
    
    struct myColors {
        float red, blue, green;
    };
    
    int colorPickerDist;
    
    ofColor colorChoice;
    

    

    
    ofColor color1,color2,color3,color4,color5;
    
    //The following 8 variables track the corners
    //Top Left X, Top Left Y, Top Right X, Top Right Y, etc.
    int tLX,tLY,tRX,tRY,bRX,bRY,bLX,bLY;
    int locMappedX, locMappedY;
    
    bool drawActivate;
    bool newShape;
    bool drawSwitch;
    bool clicked;
    bool colorPickerBegin;
    int pointWeight;
};
